import re
import string
from xmlrpclib import True, False, Server

pikePort = 81

defaultCss = """
"""

defaultCustomPrefs = """
"""

defaultJavaScript = """
"""

defaultJoinNowMembersBox = """
"""

defaultNavigation = """
"""

defaultNewsDayTemplate = """
"""

defaultSignOutMembersBox = """
"""

defaultSiteStructure = """
"""

defaultTemplate = """
"""

class DocumentControl:
    """documentcontrol"""

    default = ""
    current = ""
    ownerName = ""
    ownerPassword = ""
    owned = 0

    meta_type = "Pike Compatible XML-RPC Document Control Responder"

    def __init__(self, defaultString, container, id, parent):
        """__init__"""
        self.default = defaultString
        self.current = defaultString
        self.container = container
        self.ownerName = ""
        self.ownerPassword = ""
        self.owned = 0
        self.id = id
        self.title = id
        self.parent = parent

    def checkIn(self, username, password, siteName):
        """checkIn"""
        print "manila." + self.id + ".checkIn:"
        print "\tusername    :", username
        print "\tpassword    :", password
        print "\tsitename    :", siteName
        print "---------------------"
        return True

    def get(self, username, password, siteName):
        """get"""
        print "manila." + self.id + ".get:"
        print "\tusername    :", username
        print "\tpassword    :", password
        print "\tsitename    :", siteName
        print "---------------------"
        return self.current

    def restoreDefault(self, username, password, sitename):
        """restoreDefault"""
        print "manila." + self.id + ".restoreDefault:"
        print "\tusername    :", username
        print "\tpassword    :", password
        print "\tsitename    :", sitename
        print "---------------------"
        self.current = self.default

    def set(self, username, password, sitename, s, windowInfo):
        """set"""
        print "manila." + self.id + ".set:"
        print "\tusername    :", username
        print "\tpassword    :", password
        print "\tsitename    :", sitename
        print "\ts           :", s
        print "\twindowInfo  :", windowInfo
        print "---------------------"
        self.current = s

class Messages:
    """messages"""

    meta_type = "Pike Compatible XML-RPC Message Responder"

    def __init__(self, id, parent):
        """   """
        self.id = id
        self.title = id
        self.parent = parent

    def addToStoriesList(self, username, password, sitename, msgNum):
        """addToStoriesList"""
        print "manila." + self.id + ".addToStoriesList:"
        print "\tusername:", username
        print "\tpassword:", password
        print "\tsitename:", sitename
        print "\tmsgNum  :", msgNum
        print "-----------------"
        return True

    def checkIn(self, username, password, siteName, msgNum):
        """checkIn"""
        print "manila." + self.id + ".checkIn:"
        print "\tusername:", username
        print "\tpassword:", password
        print "\tsiteName:", siteName
        print "\tmsgNum  :", msgNum
        print "-----------------"
        return True

    def isStory(self, username, password, sitename, msgNum):
        """isStory"""
        print "manila." + self.id + ".isStory:"
        print "\tusername:", username
        print "\tpassword:", password
        print "\tsitename:", sitename
        print "\tmsgNum  :", msgNum
        print "-----------------"
        return False

    def removeFromStoriesList(self, username, password, siteName, msgNum):
        """removeFromStoriesList"""
        print "manila." + self.id + ".removeFromStoriesList:"
        print "\tusername:", username
        print "\tpassword:", password
        print "\tsitename:", siteName
        print "\tmsgNum  :", msgNum
        print "-----------------"
        return True

    def create(self, username, password, sitename, subject, body,
               bodyType, inResponseTo, windowInfo, rendererInfo):
        """create"""
        print "manila." + self.id + ".create:"
        print "\tusername    :", username
        print "\tpassword    :", password
        print "\tsitename    :", sitename
        print "\tsubject     :", subject
        print "\tbody        :", body
        print "\tbodyType    :", bodyType
        print "\tinResponseTo:", inResponseTo
        print "\twindowInfo  :", windowInfo
        print "\trendererInfo:", rendererInfo
        print "---------------------"
        storyInfo = {}
        return storyInfo

    def set(self, username, password, sitename, msgnum, subject, body,
            bodyType, windowInfo, rendererInfo):
        """set"""
        print "manila." + self.id + ".set:"
        print "\tusername    :", username
        print "\tpassword    :", password
        print "\tsitename    :", sitename
        print "\tmsgnum      :", msgnum
        print "\tsubject     :", subject
        print "\tbody        :", body
        print "\tbodyType    :", bodyType
        print "\twindowInfo  :", windowInfo
        print "\trendererInfo:", rendererInfo
        print "---------------------"
        doc = self.parent.getZFDocument(msgnum)
        doc.manage_edit(body, subject)
        doc.pikeWindowInfo = windowInfo
        storyInfo = self.parent.getStoryInfo(doc, None, username = username)
        return storyInfo

class PikeCompatibility:
    """The Pike Compatible XML-RPC interface"""

    meta_type = "Pike Compatible XML-RPC Interface"

    def __init__(self):
        self.id = "manila"
        self.title = "Pike Compatible XML-RPC Interface"
        self.docs = {}
        
        self.css = DocumentControl(
            defaultCss,
            None,
            "css",
            self)
        self.customPrefs = DocumentControl(
            defaultCustomPrefs,
            None,
            "customPrefs",
            self)
        self.javaScript = DocumentControl(
            defaultJavaScript,
            None,
            "javaScript",
            self)
        self.joinNowMembersBox = DocumentControl(
            defaultJoinNowMembersBox,
            None,
            "joinNowMembersBox",
            self)
        self.message = Messages("message", self)
        self.navigation = DocumentControl(
            defaultNavigation,
            None,
            "navigation",
            self)
        self.newsDayTemplate = DocumentControl(
            defaultNewsDayTemplate,
            None,
            "newsDayTemplate",
            self)
        self.signOutMembersBox = DocumentControl(
            defaultSignOutMembersBox,
            None,
            "signOutMembersBox",
            self)
        self.siteStructure = DocumentControl(
            defaultSiteStructure,
            None,
            "siteStructure",
            self)
        self.template = DocumentControl(
            defaultTemplate,
            None,
            "template",
            self)

    def pikeFilter(self, body):
        """pikeFilter"""
        body = re.sub("\r\n", "\n", body)
        body = re.sub("\n", "\r", body)
        return body

    def editInPike(self, doc, REQUEST):
        """   """
        self.registerZFDocument(doc)
        storyInfo = self.getStoryInfo(doc, REQUEST)
        siteInfo = self.getSiteInfo(doc, REQUEST)
        self.getPikeServer(REQUEST).pike.editStory(siteInfo, storyInfo)
        if REQUEST is not None:
            return REQUEST['RESPONSE'].redirect(self.getDocURL(doc, REQUEST))

    def getDocURL(self, doc, REQUEST):
        """getDocURL"""
        if doc.__dict__.has_key('pikeDocumentURL'):
            url = doc.pikeDocumentURL
            if len(url) < 7 or url[:-7] != "http://":
                if REQUEST is None:
                    url = doc.absolute_url()
                else:
                    url = REQUEST.BASE1 + url
        else:
            url = doc.absolute_url()
        return url

    def getStoryInfo(self, doc, REQUEST=None, username=None):
        """   """
        if REQUEST is None:
            member = username
        else:
            member = REQUEST.AUTHENTICATED_USER.getUserName()

        storyInfo = {}
        storyInfo['body'] = self.pikeFilter(doc.read())
        storyInfo['member'] = member
        storyInfo['msgnum'] = doc.absolute_url()
        storyInfo['postTime'] = ""
        storyInfo['lastUpdate'] = str(doc.bobobase_modification_time)
        storyInfo['ctReads'] = 0
        storyInfo['subject'] = doc.title
        storyInfo['responses'] = []
        storyInfo['URL'] = self.getDocURL(doc, REQUEST)

        if doc.__dict__.has_key('pikewindowInfo'):
            storyInfo['windowInfo'] = doc.pikeWindowInfo
        
        return storyInfo

    def getSiteInfo(self, doc, REQUEST):
        """   """
        host = REQUEST.HTTP_HOST
        i = string.find(host, ":")
        if i != -1:
            host = host[0:i]

        siteInfo = {}
        siteInfo['host'] = host
        siteInfo['port'] = REQUEST.SERVER_PORT
        siteInfo['rpcPath'] = "/" + doc.absolute_url(1)
        siteInfo['siteName'] = host
        siteInfo['displaySiteName'] = host
        siteInfo['username'] = REQUEST.AUTHENTICATED_USER.getUserName()
        siteInfo['password'] = ""
        siteInfo['URL'] = self.getDocURL(doc, REQUEST)
        return siteInfo

    def getPikeServer(self, REQUEST):
        """   """
        return Server("http://" + REQUEST.REMOTE_ADDR + ":" + str(pikePort))

    def registerZFDocument(self, doc):
        """registerZFDocument"""
        self.docs[doc.absolute_url()] = doc

    def getZFDocument(self, key):
        """getZFDocument"""
        if not self.docs.has_key(key):
            raise AttributeError
        else:
            return self.docs[key]

PikeCompatible = PikeCompatibility()

class PikeEdit:
    manila = PikeCompatible # needs to be called 'manila' or XML-RPC won't find it.

    def editInPike(self, REQUEST):
        """editInPike"""
        if self.may_edit(REQUEST):
            self.manila.editInPike(self, REQUEST)

    def may_edit(self, REQUEST):
        """may_edit"""
        return REQUEST.AUTHENTICATED_USER.has_role('Manager', 'Owner')

    def edit_in_pike_button(self, REQUEST, linkText=None):
        """editInPikeButton"""
        if self.may_edit(REQUEST):
            if linkText is not None:
                return "<a href=\"" + \
                       self.absolute_url() + \
                       "/editInPike\">" + \
                       linkText + \
                       "</a>"
            else:
                return "<form action=\"" + \
                       self.absolute_url() + \
                       "/editInPike\" method=\"POST\">\n" + \
                       "<input name=\"SUBMIT\" type=\"SUBMIT\" value=\"Edit In Pike\">\n" + \
                       "</form>"
        else:
            return "<!-- user cannot edit -->"

    def edit_in_browser_button(self, REQUEST, linkText=None):
        """editInBrowserButton"""
        if self.may_edit(REQUEST):
            if linkText is not None:
                return "<a href=\"" + \
                       self.absolute_url() + \
                       "/manage_editForm\">" + \
                       linkText + \
                       "</a>"
            else:
                return "<form action=\"" + \
                       self.absolute_url() + \
                       "/manage_editForm\" method=\"POST\">\n" + \
                       "<input name=\"SUBMIT\" type=\"SUBMIT\" value=\"Edit This Page\">\n" + \
                       "</form>"
        else:
            return "<!-- user cannot edit -->"


